transformers-0.4.2.0: Concrete functor and monad transformers

Copyright | (c) Ross Paterson 2014
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Data.Functor.Sum

Description

Sums, lifted to functors.

Synopsis

- data Sum f g a
  - = InL (f a)
  - | InR (g a)

# Documentation

data Sum f g a Source

Lifted sum of functors.

Constructors

InL (f a) |
InR (g a) |

Instances

(Functor f, Functor g) => Functor (Sum f g) |
(Foldable f, Foldable g) => Foldable (Sum f g) |
(Traversable f, Traversable g) => Traversable (Sum f g) |
(Show1 f, Show1 g) => Show1 (Sum f g) |
(Read1 f, Read1 g) => Read1 (Sum f g) |
(Ord1 f, Ord1 g) => Ord1 (Sum f g) |
(Eq1 f, Eq1 g) => Eq1 (Sum f g) |
(Eq1 f, Eq1 g, Eq a) => Eq (Sum f g a) |
(Ord1 f, Ord1 g, Ord a) => Ord (Sum f g a) |
(Read1 f, Read1 g, Read a) => Read (Sum f g a) |
(Show1 f, Show1 g, Show a) => Show (Sum f g a) |